/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package calculator.operation;

import calculator.*;

/**
 *
 * @author tomorrow
 */
public class Operation {

    private String firstNumber = "";
    private String secondNumber = "";
    private OperationType type;

    public String execute() throws ExecuteException {
        if (type == null) {
            throw new ExecuteException("type must not be null");
        }
        if ("".equals(firstNumber)) {
            throw new ExecuteException("firstNumber must not be empty string");
        }
        if ("".equals(secondNumber)) {
            throw new ExecuteException("secondNumber must not be empty string");
        }
        double first = Double.parseDouble(firstNumber);
        double second = Double.parseDouble(secondNumber);
        double result = 0;
        switch (type) {
            case ADD:
                result = first + second;
                break;
            case SUBTRACT:
                result = first - second;
                break;
            case MULTIPLY:
                result = first * second;
                break;
            case DIVIDE:
                if (second == 0) {
                    throw new ExecuteException("zero division");
                }
                result = first / second;
                break;
        }
        clear();
        return Double.toString(result);
    }

    private void clear() {
        firstNumber = "";
        secondNumber = "";
        type = null;
    }

    public String addToNumber(char c) {
        if (getType() != null) {
            if(secondNumber.length()<20){
            secondNumber = secondNumber + c;
            }
            return secondNumber;
        } else {
            if(firstNumber.length() < 20){
                firstNumber = firstNumber + c;
            }
            return firstNumber;
        }
    }

    public String getActualNumber() {
        String result;
        if (type != null) {
            result = secondNumber;
        } else {
            result = firstNumber;
        }
        return "".equals(result)?"0":result;
    }

    public String addDecimalPoint() {
        String returnString;
        if (getType() != null) {
            returnString = secondNumber;
            if (!secondNumber.contains(".") && secondNumber.length() < 19) {
                secondNumber = secondNumber + '.';
            }
        } else {
            returnString = firstNumber;
            if (!firstNumber.contains(".") && firstNumber.length() < 19) {
                firstNumber = firstNumber + '.';
            }
        }
        return returnString;
    }

    public String getFirstNumber() {
        return firstNumber;
    }

    public void setFirstNumber(String firstNumber) {
        this.firstNumber = firstNumber;
    }

    public String getSecondNumber() {
        return secondNumber;
    }

    public void setSecondNumber(String secondNumber) {
        this.secondNumber = secondNumber;
    }

    public OperationType getType() {
        return type;
    }

    public void setType(OperationType type) {
        this.type = type;
    }
}
